
;CodeVisionAVR C Compiler V2.03.4 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATtiny2313
;Clock frequency        : 4,000000 MHz
;Memory model           : Tiny
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 32 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;global const stored in FLASH  : Yes
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny2313
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F
	.EQU GPIOR0=0x13
	.EQU GPIOR1=0x14
	.EQU GPIOR2=0x15

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _i=R3
	.DEF _ds18b20_devices=R2

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_conv_delay_G101:
	.DB  0x64,0x0,0xC8,0x0,0x90,0x1,0x20,0x3
_bit_mask_G101:
	.DB  0xF8,0xFF,0xFC,0xFF,0xFE,0xFF,0xFF,0xFF

;GPIOR0-GPIOR2 INITIALIZATION
	.EQU  __GPIOR0_INIT=0x00
	.EQU  __GPIOR1_INIT=0x00
	.EQU  __GPIOR2_INIT=0x00

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	LDI  R30,__GPIOR1_INIT
	OUT  GPIOR1,R30
	LDI  R30,__GPIOR2_INIT
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x80)
	LDI  R29,HIGH(0x80)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.03.4 Standard
;Automatic Program Generator
; Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 24.05.2010
;Author  :
;Company :
;Comments:
;
;
;Chip type           : ATtiny2313
;Clock frequency     : 4,000000 MHz
;Memory model        : Tiny
;External RAM size   : 0
;Data Stack size     : 32
;*****************************************************/
;typedef  unsigned char byte ;
;#pragma optsize+
;#include <tiny2313.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <bcd.h>
;                       //Array Symbol image
;#define a 32
;#define b 128
;#define c 2
;#define d 8               //     
;#define e 16
;#define f 64
;#define g 1
;#define DP 4
;#define minus Dig[10]
;#define grad  Dig[11]
;#define probel Dig[12]
;
;
;
;
; byte  Dig[13],
;          ind [8],  // indicator image
;
;          i   ,     // Number symbol on display
;
;          number_razr [8] ,  // data razryadow-zajiganie
;
;          ustan_pinow [8];   // config registra d  na wix chto gorit ,ost na wxod
;
;   void Dig_init()
; 0000 0035  {

	.CSEG
_Dig_init:
; 0000 0036 
; 0000 0037   Dig[0] = (a+b+c+d+e+f);   //       
	LDI  R30,LOW(250)
	STS  _Dig,R30
; 0000 0038   Dig[1] = (b+c);
	LDI  R30,LOW(130)
	__PUTB1MN _Dig,1
; 0000 0039   Dig[2] = (a+b+g+e+d);
	LDI  R30,LOW(185)
	__PUTB1MN _Dig,2
; 0000 003A   Dig[3] = (a+b+g+c+d);
	LDI  R30,LOW(171)
	__PUTB1MN _Dig,3
; 0000 003B   Dig[4] = (f+g+b+c);
	LDI  R30,LOW(195)
	__PUTB1MN _Dig,4
; 0000 003C   Dig[5] = (a+f+g+c+d);
	LDI  R30,LOW(107)
	__PUTB1MN _Dig,5
; 0000 003D   Dig[6] = (a+f+g+c+d+e);
	LDI  R30,LOW(123)
	__PUTB1MN _Dig,6
; 0000 003E   Dig[7] = (a+b+c);
	LDI  R30,LOW(162)
	__PUTB1MN _Dig,7
; 0000 003F   Dig[8] = (a+b+c+d+e+f+g);
	LDI  R30,LOW(251)
	__PUTB1MN _Dig,8
; 0000 0040   Dig[9] = (a+b+c+d+f+g);
	LDI  R30,LOW(235)
	__PUTB1MN _Dig,9
; 0000 0041   Dig[10] = (g);
	LDI  R30,LOW(1)
	__PUTB1MN _Dig,10
; 0000 0042   Dig[11] = (a+b+f+g);
	LDI  R30,LOW(225)
	__PUTB1MN _Dig,11
; 0000 0043   Dig[12]=  0;
	LDI  R30,LOW(0)
	__PUTB1MN _Dig,12
; 0000 0044 
; 0000 0045   number_razr [0]  = ~16;
	LDI  R30,LOW(239)
	STS  _number_razr,R30
; 0000 0046   number_razr [1]  = ~1;
	LDI  R30,LOW(254)
	__PUTB1MN _number_razr,1
; 0000 0047   number_razr [2]  = ~2;     //  - 0
	LDI  R30,LOW(253)
	__PUTB1MN _number_razr,2
; 0000 0048   number_razr [3]  = ~32;
	LDI  R30,LOW(223)
	__PUTB1MN _number_razr,3
; 0000 0049   number_razr [4]  = 16 ;    //   - 1
	LDI  R30,LOW(16)
	__PUTB1MN _number_razr,4
; 0000 004A   number_razr [5]  = 1   ;
	LDI  R30,LOW(1)
	__PUTB1MN _number_razr,5
; 0000 004B   number_razr [6]  = 2   ;
	LDI  R30,LOW(2)
	__PUTB1MN _number_razr,6
; 0000 004C   number_razr [7]  = 32;
	LDI  R30,LOW(32)
	__PUTB1MN _number_razr,7
; 0000 004D 
; 0000 004E 
; 0000 004F    ustan_pinow [0]=16;
	LDI  R30,LOW(16)
	STS  _ustan_pinow,R30
; 0000 0050    ustan_pinow [1]=1;
	LDI  R30,LOW(1)
	__PUTB1MN _ustan_pinow,1
; 0000 0051    ustan_pinow [2]=2;
	LDI  R30,LOW(2)
	__PUTB1MN _ustan_pinow,2
; 0000 0052    ustan_pinow [3]=32;       //  DDR
	LDI  R30,LOW(32)
	__PUTB1MN _ustan_pinow,3
; 0000 0053    ustan_pinow [4]=16;
	LDI  R30,LOW(16)
	__PUTB1MN _ustan_pinow,4
; 0000 0054    ustan_pinow [5]=1;
	LDI  R30,LOW(1)
	__PUTB1MN _ustan_pinow,5
; 0000 0055    ustan_pinow [6]=2;
	LDI  R30,LOW(2)
	__PUTB1MN _ustan_pinow,6
; 0000 0056    ustan_pinow [7]=32;
	LDI  R30,LOW(32)
	__PUTB1MN _ustan_pinow,7
; 0000 0057 
; 0000 0058 
; 0000 0059   }
	RET
;                // Timer 0 overflow interrupt service routine
; interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 005C   {
_timer0_ovf_isr:
	ST   -Y,R26
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 005D     // Reinitialize Timer 0 value
; 0000 005E   TCNT0=0xF7;
	LDI  R30,LOW(247)
	OUT  0x32,R30
; 0000 005F   DDRB=255;
	LDI  R30,LOW(255)
	OUT  0x17,R30
; 0000 0060   if (i< 4)
	LDI  R30,LOW(4)
	CP   R3,R30
	BRSH _0x3
; 0000 0061   {
; 0000 0062     PORTB=ind[i];   // i-       - 1    0  3-
	LDI  R26,LOW(_ind)
	RCALL SUBOPT_0x0
	RJMP _0x2A
; 0000 0063   }
; 0000 0064 
; 0000 0065  else
_0x3:
; 0000 0066    {
; 0000 0067    PORTB=~ind[i];   // i-        - 0    4-  7
	LDI  R26,LOW(_ind)
	RCALL SUBOPT_0x0
	COM  R30
_0x2A:
	OUT  0x18,R30
; 0000 0068    }
; 0000 0069 
; 0000 006A     DDRD= ustan_pinow [i];
	LDI  R26,LOW(_ustan_pinow)
	RCALL SUBOPT_0x0
	OUT  0x11,R30
; 0000 006B     PORTD= number_razr [i] & 0b00110011 ; //     i- 
	LDI  R26,LOW(_number_razr)
	RCALL SUBOPT_0x0
	ANDI R30,LOW(0x33)
	OUT  0x12,R30
; 0000 006C 
; 0000 006D   i++ ;                    //  increment
	INC  R3
; 0000 006E   if (i>7) i=0;          //    if last symbol
	LDI  R30,LOW(7)
	CP   R30,R3
	BRSH _0x5
	CLR  R3
; 0000 006F 
; 0000 0070  }
_0x5:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R26,Y+
	RETI
;
;
;              // 1 Wire Bus functions
; #asm
   .equ __w1_port=0x12 ;PORTD
   .equ __w1_bit=6
; 0000 0077  #endasm
;   #include <1wire.h>
;#include <ds18x20_v2.h>
;
;#define MAX_DS18b20 2
;
;byte ds18b20_devices;
;
;byte ds18b20_rom_codes[MAX_DS18b20][9];
;
;
;                  void main(void)             //  
; 0000 0083  {
_main:
; 0000 0084 
; 0000 0085  unsigned int temp[2];
; 0000 0086 
; 0000 0087   byte n , tempb, initResult, sign[2] ; //             - 
; 0000 0088 
; 0000 0089 
; 0000 008A 
; 0000 008B    Dig_init();
	SBIW R28,6
;	temp -> Y+2
;	n -> R17
;	tempb -> R16
;	initResult -> R19
;	sign -> Y+0
	RCALL _Dig_init
; 0000 008C 
; 0000 008D 
; 0000 008E              // Crystal Oscillator division factor: 1
; 0000 008F   #pragma optsize-
; 0000 0090   CLKPR=0x80;
	LDI  R30,LOW(128)
	OUT  0x26,R30
; 0000 0091   CLKPR=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 0092   #ifdef _OPTIMIZE_SIZE_
; 0000 0093   #pragma optsize+
; 0000 0094   #endif
; 0000 0095 
; 0000 0096            // Timer/Counter 0 initialization
; 0000 0097          // Clock source: System Clock
; 0000 0098         // Clock value: 3,906 kHz
; 0000 0099        // Mode: Normal top=FFh
; 0000 009A       // OC0A output: Disconnected
; 0000 009B       // OC0B output: Disconnected
; 0000 009C   TCCR0A=0x00;
	OUT  0x30,R30
; 0000 009D   TCCR0B=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
; 0000 009E   TCNT0=0xF7;
	LDI  R30,LOW(247)
	OUT  0x32,R30
; 0000 009F   OCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x36,R30
; 0000 00A0   OCR0B=0x00;
	OUT  0x3C,R30
; 0000 00A1 
; 0000 00A2                         // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 00A3  TIMSK=0x02;
	LDI  R30,LOW(2)
	OUT  0x39,R30
; 0000 00A4 
; 0000 00A5  //#asm("cli")
; 0000 00A6 
; 0000 00A7   // initResult = w1_init();
; 0000 00A8 
; 0000 00A9   initResult =0;
	LDI  R19,LOW(0)
; 0000 00AA   // ds18b20_devices=w1_search(0xf0,ds18b20_rom_codes);
; 0000 00AB 
; 0000 00AC  //#asm("sei")
; 0000 00AD 
; 0000 00AE 
; 0000 00AF 
; 0000 00B0 
; 0000 00B1                // Determine the number of DS1820 devices
; 0000 00B2 
; 0000 00B3    //delay_ms (5000);
; 0000 00B4 
; 0000 00B5  while (1)
_0x6:
; 0000 00B6   {
; 0000 00B7     if
; 0000 00B8          ( initResult  !=0 )
	CPI  R19,0
	BRNE PC+2
	RJMP _0x9
; 0000 00B9 
; 0000 00BA    {
; 0000 00BB 
; 0000 00BC       delay_ms (10000);
	LDI  R30,LOW(10000)
	LDI  R31,HIGH(10000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 00BD 
; 0000 00BE      for(n=0; n < ds18b20_devices; n++)
	LDI  R17,LOW(0)
_0xB:
	CP   R17,R2
	BRSH _0xC
; 0000 00BF      {
; 0000 00C0 
; 0000 00C1          #asm("cli")                                                                     //   2- 
	cli
; 0000 00C2         temp[n]=ds18b20_temperature(&ds18b20_rom_codes[n][0]) ;
	RCALL SUBOPT_0x1
	ADD  R30,R26
	MOV  R18,R30
	MOV  R30,R17
	LDI  R26,LOW(9)
	RCALL __MULB12U
	SUBI R30,-LOW(_ds18b20_rom_codes)
	ST   -Y,R30
	RCALL _ds18b20_temperature
	MOV  R26,R18
	RCALL SUBOPT_0x2
; 0000 00C3          #asm("sei")
	sei
; 0000 00C4 
; 0000 00C5       }
	SUBI R17,-1
	RJMP _0xB
_0xC:
; 0000 00C6 
; 0000 00C7 
; 0000 00C8 
; 0000 00C9 
; 0000 00CA 
; 0000 00CB 
; 0000 00CC    for (n=0; n < ds18b20_devices; n++)
	LDI  R17,LOW(0)
_0xE:
	CP   R17,R2
	BRLO PC+2
	RJMP _0xF
; 0000 00CD     {
; 0000 00CE 
; 0000 00CF       if (temp[n]==0x1000)
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0x1000)
	LDI  R26,HIGH(0x1000)
	CPC  R31,R26
	BRNE _0x10
; 0000 00D0         { //    1000
; 0000 00D1                 temp[n]=0;
	RCALL SUBOPT_0x1
	ADD  R26,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL SUBOPT_0x2
; 0000 00D2 
; 0000 00D3          if (n==0)
	CPI  R17,0
	BRNE _0x11
; 0000 00D4            {
; 0000 00D5 
; 0000 00D6             ind[3]=probel;
	RCALL SUBOPT_0x4
	__PUTB1MN _ind,3
; 0000 00D7             ind[2]=probel;                        //  
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
; 0000 00D8             ind[1]=Dig[0];
	LDS  R30,_Dig
	__PUTB1MN _ind,1
; 0000 00D9 
; 0000 00DA            }
; 0000 00DB           else
	RJMP _0x12
_0x11:
; 0000 00DC              {                                                   //       T =0
; 0000 00DD 
; 0000 00DE              ind[7]=probel;
	RCALL SUBOPT_0x4
	__PUTB1MN _ind,7
; 0000 00DF              ind[6]=probel;
	RCALL SUBOPT_0x4
	__PUTB1MN _ind,6
; 0000 00E0              ind[5]=Dig[0];
	LDS  R30,_Dig
	__PUTB1MN _ind,5
; 0000 00E1             }
_0x12:
; 0000 00E2          }
; 0000 00E3       else
	RJMP _0x13
_0x10:
; 0000 00E4 
; 0000 00E5       {
; 0000 00E6 
; 0000 00E7           sign[n]=0;
	RCALL SUBOPT_0x6
	LDI  R30,LOW(0)
	ST   X,R30
; 0000 00E8 
; 0000 00E9          if (temp[n] > 0x1000)
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x3
	CPI  R30,LOW(0x1001)
	LDI  R26,HIGH(0x1001)
	CPC  R31,R26
	BRLO _0x14
; 0000 00EA 
; 0000 00EB           {                                 //    1000
; 0000 00EC             temp[n] =4096-temp[n];
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x3
	LDI  R26,LOW(4096)
	LDI  R27,HIGH(4096)
	RCALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	MOV  R26,R0
	RCALL SUBOPT_0x2
; 0000 00ED             sign[n]=1;           //   4096
	RCALL SUBOPT_0x6
	LDI  R30,LOW(1)
	ST   X,R30
; 0000 00EE 
; 0000 00EF 
; 0000 00F0 
; 0000 00F1                }
; 0000 00F2 
; 0000 00F3             //   ""
; 0000 00F4 
; 0000 00F5            else
	RJMP _0x15
_0x14:
; 0000 00F6            {
; 0000 00F7             if (n==0)
	CPI  R17,0
	BRNE _0x16
; 0000 00F8                {
; 0000 00F9                  ind[2]=probel;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
; 0000 00FA                  ind[3]=probel;
	RCALL SUBOPT_0x4
	__PUTB1MN _ind,3
; 0000 00FB                }
; 0000 00FC 
; 0000 00FD             else
	RJMP _0x17
_0x16:
; 0000 00FE              {
; 0000 00FF                 ind[6]=probel;
	RCALL SUBOPT_0x4
	__PUTB1MN _ind,6
; 0000 0100                 ind[7]=probel;
	RCALL SUBOPT_0x4
	__PUTB1MN _ind,7
; 0000 0101               }
_0x17:
; 0000 0102 
; 0000 0103              }
_0x15:
; 0000 0104 
; 0000 0105          if ((temp[n] & 0x000F) >= 0x0008)
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x3
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	SBIW R30,8
	BRLO _0x18
; 0000 0106             temp[n] = (temp[n] >> 4) + 1;
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x3
	RCALL __LSRW4
	ADIW R30,1
	RJMP _0x2B
; 0000 0107          else                                        //      
_0x18:
; 0000 0108             temp[n] = (temp[n] >> 4);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x3
	RCALL __LSRW4
_0x2B:
	MOV  R26,R0
	RCALL SUBOPT_0x2
; 0000 0109 
; 0000 010A          tempb = bin2bcd((char) temp[n]);
	RCALL SUBOPT_0x1
	ADD  R26,R30
	LD   R30,X
	ST   -Y,R30
	RCALL _bin2bcd
	MOV  R16,R30
; 0000 010B 
; 0000 010C          if (n == 0)
	CPI  R17,0
	BRNE _0x1A
; 0000 010D          {
; 0000 010E             ind[1] = Dig[(tempb & 0x0F)];
	RCALL SUBOPT_0x8
	__PUTB1MN _ind,1
; 0000 010F 
; 0000 0110             if ((tempb >> 4) == 0)
	RCALL SUBOPT_0x9
	CPI  R30,0
	BRNE _0x1B
; 0000 0111 
; 0000 0112               {
; 0000 0113                if
; 0000 0114                    (sign[n]==1)
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0xA
	BRNE _0x1C
; 0000 0115                          ind[2]=minus;
	RCALL SUBOPT_0xB
	RJMP _0x2C
; 0000 0116                 else
_0x1C:
; 0000 0117                          ind[2]=probel;
	RCALL SUBOPT_0x4
_0x2C:
	__PUTB1MN _ind,2
; 0000 0118                }
; 0000 0119 
; 0000 011A             else
	RJMP _0x1E
_0x1B:
; 0000 011B 
; 0000 011C               {
; 0000 011D                  ind[2]=Dig[(tempb >> 4)];
	RCALL SUBOPT_0x9
	SUBI R30,-LOW(_Dig)
	LD   R30,Z
	RCALL SUBOPT_0x5
; 0000 011E 
; 0000 011F                  if (sign[n]==1)
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0xA
	BRNE _0x1F
; 0000 0120                          ind[3]=minus;
	RCALL SUBOPT_0xB
	RJMP _0x2D
; 0000 0121                   else
_0x1F:
; 0000 0122                       ind[3]=probel;
	RCALL SUBOPT_0x4
_0x2D:
	__PUTB1MN _ind,3
; 0000 0123               }
_0x1E:
; 0000 0124 
; 0000 0125          }
; 0000 0126 
; 0000 0127          else
	RJMP _0x21
_0x1A:
; 0000 0128 
; 0000 0129           {
; 0000 012A 
; 0000 012B             ind[5] = Dig[(tempb & 0x0F)];
	RCALL SUBOPT_0x8
	__PUTB1MN _ind,5
; 0000 012C 
; 0000 012D             if ((tempb >> 4) == 0)
	RCALL SUBOPT_0x9
	CPI  R30,0
	BRNE _0x22
; 0000 012E 
; 0000 012F               {
; 0000 0130                 if
; 0000 0131                     (sign[n]==1)
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0xA
	BRNE _0x23
; 0000 0132                          ind[6]=minus;
	RCALL SUBOPT_0xB
	RJMP _0x2E
; 0000 0133                 else
_0x23:
; 0000 0134                     ind[6]=probel;
	RCALL SUBOPT_0x4
_0x2E:
	__PUTB1MN _ind,6
; 0000 0135                }
; 0000 0136 
; 0000 0137 
; 0000 0138             else
	RJMP _0x25
_0x22:
; 0000 0139 
; 0000 013A               {
; 0000 013B                 ind[6]=Dig[(tempb >> 4)];
	RCALL SUBOPT_0x9
	SUBI R30,-LOW(_Dig)
	LD   R30,Z
	__PUTB1MN _ind,6
; 0000 013C 
; 0000 013D                    if
; 0000 013E 
; 0000 013F                        (sign[n]==1)
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0xA
	BRNE _0x26
; 0000 0140                               ind[7]=minus;
	RCALL SUBOPT_0xB
	RJMP _0x2F
; 0000 0141                    else
_0x26:
; 0000 0142 
; 0000 0143                         ind[7]=probel;
	RCALL SUBOPT_0x4
_0x2F:
	__PUTB1MN _ind,7
; 0000 0144 
; 0000 0145 
; 0000 0146              }
_0x25:
; 0000 0147           }
_0x21:
; 0000 0148       }
_0x13:
; 0000 0149 
; 0000 014A 
; 0000 014B 
; 0000 014C 
; 0000 014D 
; 0000 014E 
; 0000 014F 
; 0000 0150 
; 0000 0151     }
	SUBI R17,-1
	RJMP _0xE
_0xF:
; 0000 0152 
; 0000 0153    }
; 0000 0154      else
	RJMP _0x28
_0x9:
; 0000 0155      {
; 0000 0156        DDRB=0;
	LDI  R30,LOW(0)
	OUT  0x17,R30
; 0000 0157        #asm("cli")
	cli
; 0000 0158 
; 0000 0159     initResult = w1_init();
	RCALL _w1_init
	MOV  R19,R30
; 0000 015A 
; 0000 015B     ds18b20_devices=w1_search(0xf0,ds18b20_rom_codes);
	LDI  R30,LOW(240)
	ST   -Y,R30
	LDI  R30,LOW(_ds18b20_rom_codes)
	ST   -Y,R30
	RCALL _w1_search
	MOV  R2,R30
; 0000 015C 
; 0000 015D     #asm("sei")
	sei
; 0000 015E       ind[1]=Dig[ds18b20_devices];
	LDI  R26,LOW(_Dig)
	ADD  R26,R2
	LD   R30,X
	__PUTB1MN _ind,1
; 0000 015F       ind[0]=grad;
	__GETB1MN _Dig,11
	STS  _ind,R30
; 0000 0160       ind[7]=probel;
	RCALL SUBOPT_0x4
	__PUTB1MN _ind,7
; 0000 0161       ind[2]= Dig[initResult];
	LDI  R26,LOW(_Dig)
	ADD  R26,R19
	LD   R30,X
	RCALL SUBOPT_0x5
; 0000 0162       ind[4]=grad;
	__GETB1MN _Dig,11
	__PUTB1MN _ind,4
; 0000 0163 
; 0000 0164 
; 0000 0165 
; 0000 0166 
; 0000 0167 
; 0000 0168     }
_0x28:
; 0000 0169 
; 0000 016A   }
	RJMP _0x6
; 0000 016B  }
_0x29:
	RJMP _0x29

	.CSEG
_bin2bcd:
    ld   r26,y+
    clr  r30
bin2bcd0:
    subi r26,10
    brmi bin2bcd1
    subi r30,-16
    rjmp bin2bcd0
bin2bcd1:
    subi r26,-10
    add  r30,r26
    ret

	.CSEG
_ds18x20_select:
	ST   -Y,R17
	RCALL _w1_init
	CPI  R30,0
	BRNE _0x2020003
	LDI  R30,LOW(0)
	RJMP _0x2040001
_0x2020003:
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0x2020004
	cli
	LDI  R30,LOW(85)
	RCALL SUBOPT_0xC
	sei
	LDI  R17,LOW(0)
_0x2020006:
	cli
	LDD  R26,Y+1
	LD   R30,X+
	STD  Y+1,R26
	RCALL SUBOPT_0xC
	sei
	SUBI R17,-LOW(1)
	CPI  R17,8
	BRLO _0x2020006
	RJMP _0x2020008
_0x2020004:
	cli
	LDI  R30,LOW(204)
	RCALL SUBOPT_0xC
	sei
_0x2020008:
	LDI  R30,LOW(1)
	RJMP _0x2040001
_ds18x20_read_spd:
	RCALL __SAVELOCR2
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _ds18x20_select
	CPI  R30,0
	BRNE _0x2020009
	LDI  R30,LOW(0)
	RJMP _0x2040002
_0x2020009:
	cli
	LDI  R30,LOW(190)
	RCALL SUBOPT_0xC
	sei
	LDI  R17,LOW(0)
	__POINTBRM 16,___ds18x20_scratch_pad
_0x202000B:
	cli
	PUSH R16
	SUBI R16,-1
	RCALL _w1_read
	POP  R26
	ST   X,R30
	sei
	SUBI R17,-LOW(1)
	CPI  R17,9
	BRLO _0x202000B
	LDI  R30,LOW(___ds18x20_scratch_pad)
	ST   -Y,R30
	LDI  R30,LOW(9)
	ST   -Y,R30
	RCALL _w1_dow_crc8
	RCALL __LNEGB1
_0x2040002:
	RCALL __LOADLOCR2
	ADIW R28,3
	RET
_ds18b20_temperature:
	ST   -Y,R17
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _ds18x20_read_spd
	CPI  R30,0
	BRNE _0x202000F
	LDI  R30,LOW(55537)
	LDI  R31,HIGH(55537)
	RJMP _0x2040001
_0x202000F:
	__GETB1MN ___ds18x20_scratch_pad,4
	SWAP R30
	ANDI R30,0xF
	LSR  R30
	ANDI R30,LOW(0x3)
	MOV  R17,R30
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _ds18x20_select
	CPI  R30,0
	BRNE _0x2020010
	LDI  R30,LOW(55537)
	LDI  R31,HIGH(55537)
	RJMP _0x2040001
_0x2020010:
	cli
	LDI  R30,LOW(68)
	RCALL SUBOPT_0xC
	sei
	MOV  R30,R17
	LDI  R26,LOW(_conv_delay_G101*2)
	LDI  R27,HIGH(_conv_delay_G101*2)
	RCALL SUBOPT_0xD
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _ds18x20_read_spd
	CPI  R30,0
	BRNE _0x2020011
	LDI  R30,LOW(55537)
	LDI  R31,HIGH(55537)
	RJMP _0x2040001
_0x2020011:
	cli
	RCALL _w1_init
	sei
	MOV  R30,R17
	LDI  R26,LOW(_bit_mask_G101*2)
	LDI  R27,HIGH(_bit_mask_G101*2)
	RCALL SUBOPT_0xD
	LDS  R26,___ds18x20_scratch_pad
	LDS  R27,___ds18x20_scratch_pad+1
	AND  R30,R26
	AND  R31,R27
_0x2040001:
	LDD  R17,Y+0
	ADIW R28,2
	RET

	.DSEG
_Dig:
	.BYTE 0xD
_ind:
	.BYTE 0x8
_number_razr:
	.BYTE 0x8
_ustan_pinow:
	.BYTE 0x8
___ds18x20_scratch_pad:
	.BYTE 0x9
_ds18b20_rom_codes:
	.BYTE 0x12

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	ADD  R26,R3
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:31 WORDS
SUBOPT_0x1:
	MOV  R30,R17
	MOV  R26,R28
	SUBI R26,-(2)
	LSL  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3:
	ADD  R26,R30
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x4:
	__GETB1MN _Dig,12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	__PUTB1MN _ind,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x6:
	MOV  R26,R28
	ADD  R26,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7:
	ADD  R30,R26
	MOV  R0,R30
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	MOV  R30,R16
	ANDI R30,LOW(0xF)
	SUBI R30,-LOW(_Dig)
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x9:
	MOV  R30,R16
	SWAP R30
	ANDI R30,0xF
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA:
	LD   R26,X
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	__GETB1MN _Dig,10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xC:
	ST   -Y,R30
	RJMP _w1_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xD:
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	RCALL __GETW1PF
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_w1_init:
	clr  r30
	cbi  __w1_port,__w1_bit
	sbi  __w1_port-1,__w1_bit
	__DELAY_USW 0x1E0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x13
	sbis __w1_port-2,__w1_bit
	ret
	__DELAY_USB 0x65
	sbis __w1_port-2,__w1_bit
	inc  r30
	__DELAY_USW 0x186
	ret

__w1_read_bit:
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x3
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0xF
	clc
	sbic __w1_port-2,__w1_bit
	sec
	ror  r30
	__DELAY_USB 0x6B
	ret

__w1_write_bit:
	clt
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x3
	sbrc r23,0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x11
	sbic __w1_port-2,__w1_bit
	rjmp __w1_write_bit0
	sbrs r23,0
	rjmp __w1_write_bit1
	ret
__w1_write_bit0:
	sbrs r23,0
	ret
__w1_write_bit1:
	__DELAY_USB 0x64
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x7
	set
	ret

_w1_read:
	ldi  r22,8
	__w1_read0:
	rcall __w1_read_bit
	dec  r22
	brne __w1_read0
	ret

_w1_write:
	ldi  r22,8
	ld   r23,y+
	clr  r30
__w1_write0:
	rcall __w1_write_bit
	brtc __w1_write1
	ror  r23
	dec  r22
	brne __w1_write0
	inc  r30
__w1_write1:
	ret

_w1_search:
	push r20
	push r21
	clr  r1
	clr  r20
	ld   r26,y
	clr  r27
__w1_search0:
	mov  r0,r1
	clr  r1
	rcall _w1_init
	tst  r30
	breq __w1_search7
	ldd  r30,y+1
	st   -y,r30
	rcall _w1_write
	ldi  r21,1
__w1_search1:
	cp   r21,r0
	brsh __w1_search6
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search2
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search3
	rcall __sel_bit
	and  r24,r25
	brne __w1_search3
	mov  r1,r21
	rjmp __w1_search3
__w1_search2:
	rcall __w1_read_bit
__w1_search3:
	rcall __sel_bit
	and  r24,r25
	ldi  r23,0
	breq __w1_search5
__w1_search4:
	ldi  r23,1
__w1_search5:
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search6:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search9
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search8
__w1_search7:
	mov  r30,r20
	pop  r21
	pop  r20
	adiw r28,2
	ret
__w1_search8:
	set
	rcall __set_bit
	rjmp __w1_search4
__w1_search9:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search10
	rjmp __w1_search11
__w1_search10:
	cp   r21,r0
	breq __w1_search12
	mov  r1,r21
__w1_search11:
	clt
	rcall __set_bit
	clr  r23
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search12:
	set
	rcall __set_bit
	ldi  r23,1
	rcall __w1_write_bit
__w1_search13:
	inc  r21
	cpi  r21,65
	brlt __w1_search1
	rcall __w1_read_bit
	rol  r30
	rol  r30
	andi r30,1
	adiw r26,8
	st   x,r30
	sbiw r26,8
	inc  r20
	tst  r1
	breq __w1_search7
	ldi  r21,9
__w1_search14:
	ld   r30,x
	adiw r26,9
	st   x,r30
	sbiw r26,8
	dec  r21
	brne __w1_search14
	rjmp __w1_search0

__sel_bit:
	mov  r30,r21
	dec  r30
	mov  r22,r30
	lsr  r30
	lsr  r30
	lsr  r30
	add  r30,r26
	clr  r31
	ld   r24,z
	ldi  r25,1
	andi r22,7
__sel_bit0:
	breq __sel_bit1
	lsl  r25
	dec  r22
	rjmp __sel_bit0
__sel_bit1:
	ret

__set_bit:
	rcall __sel_bit
	brts __set_bit2
	com  r25
	and  r24,r25
	rjmp __set_bit3
__set_bit2:
	or   r24,r25
__set_bit3:
	st   z,r24
	ret

_w1_dow_crc8:
	clr  r30
	ld   r24,y
	tst  r24
	breq __w1_dow_crc83
	ldi  r22,0x18
	ldd  r26,y+1
	clr  r27
__w1_dow_crc80:
	ldi  r25,8
	ld   r31,x+
__w1_dow_crc81:
	mov  r23,r31
	eor  r23,r30
	ror  r23
	brcc __w1_dow_crc82
	eor  r30,r22
__w1_dow_crc82:
	ror  r30
	lsr  r31
	dec  r25
	brne __w1_dow_crc81
	dec  r24
	brne __w1_dow_crc80
__w1_dow_crc83:
	adiw r28,2
	ret

__LSRW4:
	LSR  R31
	ROR  R30
__LSRW3:
	LSR  R31
	ROR  R30
__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__MULB12U:
	MOV  R0,R26
	SUB  R26,R26
	LDI  R27,9
	RJMP __MULB12U1
__MULB12U3:
	BRCC __MULB12U2
	ADD  R26,R0
__MULB12U2:
	LSR  R26
__MULB12U1:
	ROR  R30
	DEC  R27
	BRNE __MULB12U3
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	DEC  R26
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
